﻿package com.selenetan.core 
{
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.events.EventDispatcher;
    import flash.events.TimerEvent;
    import flash.utils.getTimer;
    import flash.utils.Timer;
	/**
     * ...
     * @author Selene
     */
    public class STTicker extends EventDispatcher
    {
        protected var _timer:Sprite;
        protected var _lastTick:uint;
        protected var _currTick:uint;
        protected var _tickEvent:STTickerEvent
        
        /**
         * Time since last tick, in seconds.
         */
        public var elapsed:Number;
        
        public function STTicker() 
        {
            _timer = new Sprite();
            _tickEvent = new STTickerEvent(STTickerEvent.TICK, 0);
            elapsed = 0;
        }
        
        protected function onTick(event:Event):void
        {
            _currTick = getTimer();
            elapsed = (_currTick - _lastTick) * 0.001;
            _lastTick = _currTick;
            _tickEvent.elapsed = elapsed;
            dispatchEvent(_tickEvent);
        }
        
        public function start():void
        {
            elapsed = 0;
            _currTick = getTimer();
            _lastTick = _currTick
            _timer.addEventListener(Event.ENTER_FRAME, onTick);
        }
        
        public function stop():void
        {
            _timer.removeEventListener(Event.ENTER_FRAME, onTick);
        }
        
    }

}