﻿package 
{
    import com.selenetan.core.STGlobal;
    import com.selenetan.librarytest.World;
	import flash.display.Sprite;
	import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.text.TextField;
	
	/**
	 * ...
	 * @author Selene
	 */
	public class Main extends Sprite 
	{
		private var world:World;
        private var reset:Sprite;
        
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
            trace("init()");
            
            graphics.beginFill(0x111111);
            graphics.drawRect(0, 0, 1024, 768);
            
            var container:Sprite = new Sprite();
            world = new World(container, 800, 600);
            STGlobal.currentWorld = world;
            trace("STGlobal.currentWorld: " + STGlobal.currentWorld);
            addChild(world.sprite);
            
            world.sprite.x = (1024 - 800) * 0.5;
            world.sprite.y = (768 - 600) * 0.5;
            
            reset = new Sprite();
            var tf:TextField = new TextField();
            tf.text = "Reset";
            tf.mouseEnabled = false;
            tf.selectable = false;
            reset.graphics.beginFill(0xCCCCEE);
            reset.graphics.drawRect(0, 0, 50, 20);
            reset.addChild(tf);
            reset.x = 10;
            reset.y = 10;
            addChild(reset);
            
            reset.addEventListener(MouseEvent.CLICK, world.reset);
		}
		
	}
	
}